"use strict";

exports.__esModule = true;
exports.updateRecordOnWalk = exports.updateRecord = exports.shouldUpdateRecords = exports.createRecord = exports.identity = void 0;

var identity = function identity(value) {
  return value;
};

exports.identity = identity;

var createRecord = function createRecord(data, _ref) {
  var recomputeTree = _ref.recomputeTree;
  var record = {
    data: data,
    isOpen: data.isOpenByDefault,
    toggle: function toggle() {
      record.isOpen = !record.isOpen;
      return recomputeTree({
        refreshNodes: record.isOpen
      });
    }
  };
  return record;
};

exports.createRecord = createRecord;

var shouldUpdateRecords = function shouldUpdateRecords(_ref2) {
  var opennessState = _ref2.opennessState,
      _ref2$useDefaultOpenn = _ref2.useDefaultOpenness,
      useDefaultOpenness = _ref2$useDefaultOpenn === void 0 ? false : _ref2$useDefaultOpenn;
  return !!opennessState || useDefaultOpenness;
};

exports.shouldUpdateRecords = shouldUpdateRecords;

var updateRecord = function updateRecord(record, recordId, _ref3) {
  var _opennessState;

  var opennessState = _ref3.opennessState,
      _ref3$useDefaultOpenn = _ref3.useDefaultOpenness,
      useDefaultOpenness = _ref3$useDefaultOpenn === void 0 ? false : _ref3$useDefaultOpenn;
  record.isOpen = useDefaultOpenness ? record.data.isOpenByDefault : (_opennessState = opennessState == null ? void 0 : opennessState[recordId]) != null ? _opennessState : record.isOpen;
};

exports.updateRecord = updateRecord;

var updateRecordOnWalk = function updateRecordOnWalk(record, _ref4) {
  var _ref4$useDefaultOpenn = _ref4.useDefaultOpenness,
      useDefaultOpenness = _ref4$useDefaultOpenn === void 0 ? false : _ref4$useDefaultOpenn;

  if (useDefaultOpenness) {
    record.isOpen = record.data.isOpenByDefault;
  }
};

exports.updateRecordOnWalk = updateRecordOnWalk;